# A-Core Base
This repository contains the top level module for A-Core implementation in Chisel. A developers' [tutorial](https://gitlab.com/a-core/a-core_documentation/tutorials/-/blob/master/a-core_chisel-dev-guide.md) is available to get you started with the A-Core hardware development.

## Features
* 32-bit
* 5 stage pipeline
* Register forwarding
* Predict-not-taken branch predictor
* Trap handling for fault-based synchronous exceptions
* Configurable M extension
* F-extension work-in-progress

## Timing information

* Integer multiplication - 2 clock cycles, pipelined
* Integer division - 36 clock cycles, not pipelined
* Jumps - 3 pipeline bubbles
* Branches -  3 pipeline bubbles if taken

## Pipeline

![ACoreBase pipeline](diagrams/pipeline.png)

### Stages
* Instruction Fetch
* Decode
* Execute and CSR
* Memory Access
* Write-Back

See their respective source files under `src/main/scala` for more detailed explanations of each stage's functionality.

### Trap handling

The implementation supports traps for fault-based synchronous exceptions. The traps are checked in Write-Back stage. There is also a sticky-bit in Memory Access stage to stop all memory writes if a preceding request was faulty.

When trap is detected, the following occurs:
1. PC of the trap-causing instruction is saved to `mepc`
2. Cause of the exception iss saved to `mcause`
3. New PC is sourced from `mtvec`
4. `PipelineController` to flushes all stages
5. Program flow continues normally
6. When `mret` instruction is called, new PC is sourced from `mepc`


### Forwarding

In case of a data hazard, data that will be written to register file can be forwarded to the instruction currently in ID stage.

### Register forwarding
Per instruction, there are three possible source registers - `rs1`, `rs2`, and `rs3`. The addresses for all of these must be compared against instructions further down the pipeline, and in case of a hazard (destination register `rd` address matches the source register address), the data needs to be replaced. 

The comparison is done at `PipelineController`, and occurs when the instruction reading source registers is in ID stage. The targets for address comparison can locate in any stage further down the pipeline - EX, MEM, WB.

To forward the correct data, not only must the stage be known, but also the source. Data for register file write can come from ALU, Program Counter, CSR, immediate, or memory. The ID stage is stalled if a hazard is detected, but the data is not yet valid.

### Control hazards (jumps, branches, traps)

The trigger for jumps and branches come from Execute stage. Therefore, both cause 3 pipeline bubbles. Branch causes the bubbles only if taken.

In case of a trap, all pipeline stages are flushed. Trap is detected from Write-Back stage.

### Structural hazard
There is one structural hazard, namely the Program Memory, which can be accessed either by instruction fetch or memory access. In case of simultaneous access, instruction fetch is stalled until the hazard is cleared. The stalling is handled by AXI4-Lite handshaking.

### [API Documentation](https://a-core.gitlab.io/a-core_chisel/ACoreBase/)

# Description of scala module version control principle with git
Generated by init_module.sh of Chisel-blocs-utils, 
https://github.com/Chisel-blocks/chisel-blocks-utils , 20201228

## Principle of operation:
All modules version controlled with this method can be used effortlessly
and recursively as git submodules inside similar modules

The method of use is _always_ the same
1. `./init_submodules.sh` (if any)
2. Publish locally the submodules you want to use.
    (embedded to init_submodules.sh)
3. `./configure && make`

## Version strings:
In build.sbt, the version of the current module is of from
"module-<commit-hash>-SNAPHOT"
It is created with line:
`version := scala.sys.process.Process("git rev-parse --short HEAD").!!.mkString.replaceAll("\\s", "")+"-SNAPSHOT"`

Dependencies on similar submodules are defined with the
function gitSubmoduleHashSnapshotVersion
and with the dependency definitions
`libraryDependencies += "edu.berkeley.cs" %% "hbwif" % gitSubmoduleHashSnapshotVersion(modulename")`

This dependency is satisfied only if there is a locally published (sbt publishLocal) submodule
with the submodule hash of the current git submodule.

**OBS1**: Every time a submodule is updated, it must be published locally.
See init_submodules.sh for reference. Make it recursive if needed.

**OBS2**: If submodules are edited and committed, the changes are visible
at the top level ONLY if ALL the entire hierarchy of submodules from bottom
module to top are git-added, git-committed and git-pushed.
This is how submodules normally operate.

## Add your module readme here
Lorem ipsum...

